# coding: utf-8

"""
    Xero Finance API

    The Finance API is a collection of endpoints which customers can use in the course of a loan application, which may assist lenders to gain the confidence they need to provide capital.  # noqa: E501

    Contact: api@xero.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401

from xero_python.models import BaseModel


class HistoryRecordResponse(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "changes": "str",
        "date_utc_string": "str",
        "date_utc": "datetime",
        "user": "str",
        "details": "str",
    }

    attribute_map = {
        "changes": "changes",
        "date_utc_string": "dateUTCString",
        "date_utc": "dateUTC",
        "user": "user",
        "details": "details",
    }

    def __init__(
        self, changes=None, date_utc_string=None, date_utc=None, user=None, details=None
    ):  # noqa: E501
        """HistoryRecordResponse - a model defined in OpenAPI"""  # noqa: E501

        self._changes = None
        self._date_utc_string = None
        self._date_utc = None
        self._user = None
        self._details = None
        self.discriminator = None

        if changes is not None:
            self.changes = changes
        if date_utc_string is not None:
            self.date_utc_string = date_utc_string
        if date_utc is not None:
            self.date_utc = date_utc
        if user is not None:
            self.user = user
        if details is not None:
            self.details = details

    @property
    def changes(self):
        """Gets the changes of this HistoryRecordResponse.  # noqa: E501

        The type of change recorded against the document  # noqa: E501

        :return: The changes of this HistoryRecordResponse.  # noqa: E501
        :rtype: str
        """
        return self._changes

    @changes.setter
    def changes(self, changes):
        """Sets the changes of this HistoryRecordResponse.

        The type of change recorded against the document  # noqa: E501

        :param changes: The changes of this HistoryRecordResponse.  # noqa: E501
        :type: str
        """

        self._changes = changes

    @property
    def date_utc_string(self):
        """Gets the date_utc_string of this HistoryRecordResponse.  # noqa: E501

        UTC date that the history record was created  # noqa: E501

        :return: The date_utc_string of this HistoryRecordResponse.  # noqa: E501
        :rtype: str
        """
        return self._date_utc_string

    @date_utc_string.setter
    def date_utc_string(self, date_utc_string):
        """Sets the date_utc_string of this HistoryRecordResponse.

        UTC date that the history record was created  # noqa: E501

        :param date_utc_string: The date_utc_string of this HistoryRecordResponse.  # noqa: E501
        :type: str
        """

        self._date_utc_string = date_utc_string

    @property
    def date_utc(self):
        """Gets the date_utc of this HistoryRecordResponse.  # noqa: E501

        UTC date that the history record was created  # noqa: E501

        :return: The date_utc of this HistoryRecordResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._date_utc

    @date_utc.setter
    def date_utc(self, date_utc):
        """Sets the date_utc of this HistoryRecordResponse.

        UTC date that the history record was created  # noqa: E501

        :param date_utc: The date_utc of this HistoryRecordResponse.  # noqa: E501
        :type: datetime
        """

        self._date_utc = date_utc

    @property
    def user(self):
        """Gets the user of this HistoryRecordResponse.  # noqa: E501

        The users first and last name  # noqa: E501

        :return: The user of this HistoryRecordResponse.  # noqa: E501
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this HistoryRecordResponse.

        The users first and last name  # noqa: E501

        :param user: The user of this HistoryRecordResponse.  # noqa: E501
        :type: str
        """

        self._user = user

    @property
    def details(self):
        """Gets the details of this HistoryRecordResponse.  # noqa: E501

        Description of the change event or transaction  # noqa: E501

        :return: The details of this HistoryRecordResponse.  # noqa: E501
        :rtype: str
        """
        return self._details

    @details.setter
    def details(self, details):
        """Sets the details of this HistoryRecordResponse.

        Description of the change event or transaction  # noqa: E501

        :param details: The details of this HistoryRecordResponse.  # noqa: E501
        :type: str
        """

        self._details = details
